//
// Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!


#ifndef GENERATED_ADFILES_ADGLOBALS_HPP
#define GENERATED_ADFILES_ADGLOBALS_HPP


// the number of reserved registers + machine registers.
#define REG_COUNT    89

// the number of save_on_entry + always_saved registers.
#define MAX_SAVED_ON_ENTRY_REG_COUNT    4
#define     SAVED_ON_ENTRY_REG_COUNT    0
#define   C_SAVED_ON_ENTRY_REG_COUNT    4

// Enumerate machine register numbers starting after reserved regs.
// in the order of occurrence in the register block.
enum MachRegisterNumbers {
  ECX_num,                  // enum   0, regnum   0, reg encode   1
  EBX_num,                  // enum   1, regnum   1, reg encode   3
  EBP_num,                  // enum   2, regnum   2, reg encode   5
  EDI_num,                  // enum   3, regnum   3, reg encode   7
  EAX_num,                  // enum   4, regnum   4, reg encode   0
  EDX_num,                  // enum   5, regnum   5, reg encode   2
  ESI_num,                  // enum   6, regnum   6, reg encode   6
  ESP_num,                  // enum   7, regnum   7, reg encode   4
  FPR0L_num,                // enum   8, regnum   8, reg encode   0
  FPR0H_num,                // enum   9, regnum   9, reg encode   0
  FPR1L_num,                // enum  10, regnum  10, reg encode   1
  FPR1H_num,                // enum  11, regnum  11, reg encode   1
  FPR2L_num,                // enum  12, regnum  12, reg encode   2
  FPR2H_num,                // enum  13, regnum  13, reg encode   2
  FPR3L_num,                // enum  14, regnum  14, reg encode   3
  FPR3H_num,                // enum  15, regnum  15, reg encode   3
  FPR4L_num,                // enum  16, regnum  16, reg encode   4
  FPR4H_num,                // enum  17, regnum  17, reg encode   4
  FPR5L_num,                // enum  18, regnum  18, reg encode   5
  FPR5H_num,                // enum  19, regnum  19, reg encode   5
  FPR6L_num,                // enum  20, regnum  20, reg encode   6
  FPR6H_num,                // enum  21, regnum  21, reg encode   6
  FPR7L_num,                // enum  22, regnum  22, reg encode   7
  FPR7H_num,                // enum  23, regnum  23, reg encode   7
  XMM0_num,                 // enum  24, regnum  24, reg encode   0
  XMM0b_num,                // enum  25, regnum  25, reg encode   0
  XMM0c_num,                // enum  26, regnum  26, reg encode   0
  XMM0d_num,                // enum  27, regnum  27, reg encode   0
  XMM0e_num,                // enum  28, regnum  28, reg encode   0
  XMM0f_num,                // enum  29, regnum  29, reg encode   0
  XMM0g_num,                // enum  30, regnum  30, reg encode   0
  XMM0h_num,                // enum  31, regnum  31, reg encode   0
  XMM1_num,                 // enum  32, regnum  32, reg encode   1
  XMM1b_num,                // enum  33, regnum  33, reg encode   1
  XMM1c_num,                // enum  34, regnum  34, reg encode   1
  XMM1d_num,                // enum  35, regnum  35, reg encode   1
  XMM1e_num,                // enum  36, regnum  36, reg encode   1
  XMM1f_num,                // enum  37, regnum  37, reg encode   1
  XMM1g_num,                // enum  38, regnum  38, reg encode   1
  XMM1h_num,                // enum  39, regnum  39, reg encode   1
  XMM2_num,                 // enum  40, regnum  40, reg encode   2
  XMM2b_num,                // enum  41, regnum  41, reg encode   2
  XMM2c_num,                // enum  42, regnum  42, reg encode   2
  XMM2d_num,                // enum  43, regnum  43, reg encode   2
  XMM2e_num,                // enum  44, regnum  44, reg encode   2
  XMM2f_num,                // enum  45, regnum  45, reg encode   2
  XMM2g_num,                // enum  46, regnum  46, reg encode   2
  XMM2h_num,                // enum  47, regnum  47, reg encode   2
  XMM3_num,                 // enum  48, regnum  48, reg encode   3
  XMM3b_num,                // enum  49, regnum  49, reg encode   3
  XMM3c_num,                // enum  50, regnum  50, reg encode   3
  XMM3d_num,                // enum  51, regnum  51, reg encode   3
  XMM3e_num,                // enum  52, regnum  52, reg encode   3
  XMM3f_num,                // enum  53, regnum  53, reg encode   3
  XMM3g_num,                // enum  54, regnum  54, reg encode   3
  XMM3h_num,                // enum  55, regnum  55, reg encode   3
  XMM4_num,                 // enum  56, regnum  56, reg encode   4
  XMM4b_num,                // enum  57, regnum  57, reg encode   4
  XMM4c_num,                // enum  58, regnum  58, reg encode   4
  XMM4d_num,                // enum  59, regnum  59, reg encode   4
  XMM4e_num,                // enum  60, regnum  60, reg encode   4
  XMM4f_num,                // enum  61, regnum  61, reg encode   4
  XMM4g_num,                // enum  62, regnum  62, reg encode   4
  XMM4h_num,                // enum  63, regnum  63, reg encode   4
  XMM5_num,                 // enum  64, regnum  64, reg encode   5
  XMM5b_num,                // enum  65, regnum  65, reg encode   5
  XMM5c_num,                // enum  66, regnum  66, reg encode   5
  XMM5d_num,                // enum  67, regnum  67, reg encode   5
  XMM5e_num,                // enum  68, regnum  68, reg encode   5
  XMM5f_num,                // enum  69, regnum  69, reg encode   5
  XMM5g_num,                // enum  70, regnum  70, reg encode   5
  XMM5h_num,                // enum  71, regnum  71, reg encode   5
  XMM6_num,                 // enum  72, regnum  72, reg encode   6
  XMM6b_num,                // enum  73, regnum  73, reg encode   6
  XMM6c_num,                // enum  74, regnum  74, reg encode   6
  XMM6d_num,                // enum  75, regnum  75, reg encode   6
  XMM6e_num,                // enum  76, regnum  76, reg encode   6
  XMM6f_num,                // enum  77, regnum  77, reg encode   6
  XMM6g_num,                // enum  78, regnum  78, reg encode   6
  XMM6h_num,                // enum  79, regnum  79, reg encode   6
  XMM7_num,                 // enum  80, regnum  80, reg encode   7
  XMM7b_num,                // enum  81, regnum  81, reg encode   7
  XMM7c_num,                // enum  82, regnum  82, reg encode   7
  XMM7d_num,                // enum  83, regnum  83, reg encode   7
  XMM7e_num,                // enum  84, regnum  84, reg encode   7
  XMM7f_num,                // enum  85, regnum  85, reg encode   7
  XMM7g_num,                // enum  86, regnum  86, reg encode   7
  XMM7h_num,                // enum  87, regnum  87, reg encode   7
  RFLAGS_num,               // enum  88, regnum  88, reg encode   8
  _last_Mach_Reg            // 89
};

// Size of register-mask in ints
#define RM_SIZE 6
// Unroll factor for loops over the data in a RegMask
#define FORALL_BODY BODY(0) BODY(1) BODY(2) BODY(3) BODY(4) BODY(5) 

class RegMask;

#endif // GENERATED_ADFILES_ADGLOBALS_HPP
